/*
 * bqfh.r.c
 * Copyright (C) 2009-2011, 2018, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <bqfx-defs.h>
#include <bqfx-inter.h>
#include <bqfx-names.h>
#include <bqfx-types.h>

#define posh(___s, ___n) \
    (___s) = (char *) (___s) - (___n)

#define rule(___s, ___n, ___t) \
    ((char *) (___s) + (___n) * (___t))

#define skip(___s, ___n) \
    (___s) = (char *) (___s) + (___n)

#undef Q
#define Q(e)				((integral_q) (e))

#define bqfset(bqfset)			((struct bqfset_type *) (bqfset))

int
_libx1f4l2_lxpi_bqfset(void *bqfset, void *node, unsigned rate, unsigned size,
		       void *aime, void *back, int (*call)(void *, void *))
{
    int delete;
    integral_q news;
    unsigned copy;
    void **text;

    news = *(integral_q *) node;

    if (bqfset(bqfset)->link_f.pick(aime, node, &copy)) {
	unsigned slip;
	void *next;

	slip = copy;

	if (slip & 1) {
	    if (news & Q(1) << slip) {
	    } else {
		slip--;
	    }
	}

	next = rule(node, size, slip);

	news >>= slip;

	if (slip & 1) {
	} else {
	    skip(next, size);

	    news >>= 1;

	    slip++;

	    if (news & Q(1)) {
		if (bqfset(bqfset)->link_f.fare(aime, next)) {
		    slip = integral_q_last;
		} else {
		    copy = slip;
		}
	    }
	}
	while (slip ^ integral_q_last) {
	    skip(next, size);

	    news >>= 2;

	    slip++;

	    if (1) {
		if (bqfset(bqfset)->link_f.fare(aime, next)) {
		    if (1) {
			break;
		    }
		} else {
		    copy = slip + (~news & Q(1));
		}
	    }

	    skip(next, size);

	    slip++;

	    if (news & Q(1)) {
		if (bqfset(bqfset)->link_f.fare(aime, next)) {
		    if (1) {
			break;
		    }
		} else {
		    copy = slip;
		}
	    }
	}

	news = *(integral_q *) node;
    }

    text = (void **) ((char *) node + size * integral_q_bits);

    rate--;

    do {
	if (rate) {
	    unsigned nine;

	    nine = copy >> 1;

	    if (nine) {
		nine--;

		skip(node, size);
		if (news & 2) {
		    delete = _libx1f4l2_fpxx_bqfset
			(*text, rate, size, back, call);
		    if (delete) {
			break;
		    } else {
			delete = call(back, node);
			if (delete) {
			    break;
			}
		    }
		}

		text++;

		{
		    delete = _libx1f4l2_fpxx_bqfset
			(*text, rate, size, back, call);
		    if (delete) {
			break;
		    }
		}

		text++;

		news >>= 2;
	    }

	    for (; nine; nine--) {
		skip(node, size);
		delete = call(back, node);
		if (delete) {
		    break;
		}

		skip(node, size);
		if (news & 2) {
		    delete = _libx1f4l2_fpxx_bqfset
			(*text, rate, size, back, call);
		    if (delete) {
			break;
		    } else {
			delete = call(back, node);
			if (delete) {
			    break;
			}
		    }
		}

		text++;

		{
		    delete = _libx1f4l2_fpxx_bqfset
			(*text, rate, size, back, call);
		    if (delete) {
			break;
		    }
		}

		text++;

		news >>= 2;
	    }

	    if (copy & ~1) {
		skip(node, size);
		delete = call(back, node);
		if (delete) {
		    break;
		}
	    }

	    if (1) {
		if (copy & 1) {
		} else {
		    delete = _libx1f4l2_lxpi_bqfset
			(bqfset, *text, rate, size, aime, back, call);
		    if (1) {
			break;
		    }
		}

		skip(node, size);
		if (news & 2) {
		    delete = _libx1f4l2_fpxx_bqfset
			(*text, rate, size, back, call);
		    if (delete) {
			break;
		    } else {
			delete = call(back, node);
			if (delete) {
			    break;
			}
		    }
		}

		text++;

		{
		    delete = _libx1f4l2_lxpi_bqfset
			(bqfset, *text, rate, size, aime, back, call);
		}
	    }
	} else {
	    unsigned nine;

	    nine = copy >> 1;

	    if (nine) {
		nine--;

		skip(node, size);
		if (news & 2) {
		    delete = _libx1f4l2_flxx_bqfset(*text, size, back, call);
		    if (delete) {
			break;
		    } else {
			delete = call(back, node);
			if (delete) {
			    break;
			}
		    }
		}

		text++;

		{
		    delete = _libx1f4l2_flxx_bqfset(*text, size, back, call);
		    if (delete) {
			break;
		    }
		}

		text++;

		news >>= 2;
	    }

	    for (; nine; nine--) {
		skip(node, size);
		delete = call(back, node);
		if (delete) {
		    break;
		}

		skip(node, size);
		if (news & 2) {
		    delete = _libx1f4l2_flxx_bqfset(*text, size, back, call);
		    if (delete) {
			break;
		    } else {
			delete = call(back, node);
			if (delete) {
			    break;
			}
		    }
		}

		text++;

		{
		    delete = _libx1f4l2_flxx_bqfset(*text, size, back, call);
		    if (delete) {
			break;
		    }
		}

		text++;

		news >>= 2;
	    }

	    if (copy & ~1) {
		skip(node, size);
		delete = call(back, node);
		if (delete) {
		    break;
		}
	    }

	    if (1) {
		if (copy & 1) {
		} else {
		    delete = _libx1f4l2_lxpe_bqfset
			(bqfset, *text, size, aime, back, call);
		    if (1) {
			break;
		    }
		}

		skip(node, size);
		if (news & 2) {
		    delete = _libx1f4l2_flxx_bqfset(*text, size, back, call);
		    if (delete) {
			break;
		    } else {
			delete = call(back, node);
			if (delete) {
			    break;
			}
		    }
		}

		text++;

		{
		    delete = _libx1f4l2_lxpe_bqfset
			(bqfset, *text, size, aime, back, call);
		}
	    }
	}
    } while (0);

    return delete;
}
