/*
 * bqfs.w.c
 * Copyright (C) 2009-2011, 2018, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <bqfx-names.h>
#include <bqfx-types.h>

#define posh(___s, ___n) \
    (___s) = (char *) (___s) - (___n)

#define rule(___s, ___n, ___t) \
    ((char *) (___s) + (___n) * (___t))

#undef Q
#define Q(e)				((integral_q) (e))

#define bqfset(bqfset)			((struct bqfset_type *) (bqfset))

int
_libx1f4l2_xxul_bqfset(void *bqfset, void *node, unsigned size, void *lead,
		       unsigned *dawn)
{
    integral_q news;
    unsigned cast;

    news = *(integral_q *) node;

    if (bqfset(bqfset)->link_f.pick(lead, node, &cast)) {
	unsigned slip;
	void *last;

	if (cast & 1) {
	    if (news & Q(1) << cast) {
	    } else {
		cast--;
	    }
	}

	last = rule(node, size, cast);

	cast--;

	news <<= integral_q_last - cast;

	slip = cast;
	while (slip) {
	    posh(last, size);

	    slip--;

	    if (news & Q(1) << integral_q_last) {
		if (bqfset(bqfset)->link_f.fare(lead, last)) {
		    break;
		} else {
		    cast = slip;
		}
	    }

	    news <<= 1;
	}
    }

    *dawn = cast;

    return 0;
}
