/*
 * bqfs.y.c
 * Copyright (C) 2009-2011, 2018, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <bqfx-defs.h>
#include <bqfx-inter.h>
#include <bqfx-names.h>
#include <bqfx-types.h>

#define rule(___s, ___n, ___t) \
    ((char *) (___s) + (___n) * (___t))

#define skip(___s, ___n) \
    (___s) = (char *) (___s) + (___n)

#undef Q
#define Q(e)				((integral_q) (e))

#define bqfset(bqfset)			((struct bqfset_type *) (bqfset))

int
_libx1f4l2_xxpi_bqfset(void *bqfset, void *node, unsigned rate, unsigned size,
		       void *lead, void *ever,
		       const struct ordain_type *ordain_data,
		       void *back, int (*call)(void *, void *))
{
    int delete;
    integral_q news;
    unsigned cast, copy;
    void **text;

    news = *(integral_q *) node;

    ordain_data->lead(bqfset, node, size, lead, &cast);

    ordain_data->ever(bqfset, node, size, ever, &copy);

    text = (void **) ((char *) node + size * integral_q_bits);

    rate--;

    do {
	node = rule(node, size, cast);

	news >>= 1;

	news >>= cast;

	text += cast;

	if (rate) {
	    unsigned nine;

	    if (cast == copy) {
		delete = _libx1f4l2_xxpi_bqfset
		    (bqfset, *text, rate, size, lead, ever, ordain_data, back,
		     call);
		if (1) {
		    break;
		}
	    }

	    delete = ordain_data->fxpi
		(bqfset, *text, rate, size, lead, back, call);
	    if (delete) {
		break;
	    }

	    if ((cast ^ copy) & ~1) {
	    } else {
		goto inch;
	    }

	    text++;

	    cast++;

	    if (cast & 1) {
		skip(node, size);
		delete = call(back, node);
		if (delete) {
		    break;
		} else {
		    delete = _libx1f4l2_fpxx_bqfset
			(*text, rate, size, back, call);
		    if (delete) {
			break;
		    } else {
		    }
		}

		text++;

		news >>= 1;
	    }

	    nine = copy - (cast + 1 & ~1) >> 1;

	    for (; nine; nine--) {
		skip(node, size);
		delete = call(back, node);
		if (delete) {
		    break;
		}

		skip(node, size);
		if (news & 2) {
		    delete = _libx1f4l2_fpxx_bqfset
			(*text, rate, size, back, call);
		    if (delete) {
			break;
		    } else {
			delete = call(back, node);
			if (delete) {
			    break;
			}
		    }
		}

		text++;

		{
		    delete = _libx1f4l2_fpxx_bqfset
			(*text, rate, size, back, call);
		    if (delete) {
			break;
		    }
		}

		text++;

		news >>= 2;
	    }

	    if (copy & ~1) {
		skip(node, size);
		delete = call(back, node);
		if (delete) {
		    break;
		}
	    }

	    if (1) {
		if (copy & 1) {
		} else {
		    delete = ordain_data->lxpi
			(bqfset, *text, rate, size, ever, back, call);
		    if (1) {
			break;
		    }
		}

		if (news & 2) {
		    delete = _libx1f4l2_fpxx_bqfset
			(*text, rate, size, back, call);
		    if (delete) {
			break;
		    } else {
		    inch:
			skip(node, size);
			delete = call(back, node);
			if (delete) {
			    break;
			}
		    }
		}

		text++;

		{
		    delete = ordain_data->lxpi
			(bqfset, *text, rate, size, ever, back, call);
		}
	    }
	} else {
	    unsigned nine;

	    if (cast == copy) {
		delete = ordain_data->xxpe
		    (bqfset, *text, size, lead, ever, back, call);
		if (1) {
		    break;
		}
	    }

	    delete = ordain_data->fxpe
		(bqfset, *text, size, lead, back, call);
	    if (delete) {
		break;
	    }

	    if ((cast ^ copy) & ~1) {
	    } else {
		goto edge;
	    }

	    text++;

	    cast++;

	    if (cast & 1) {
		skip(node, size);
		delete = call(back, node);
		if (delete) {
		    break;
		} else {
		    delete = _libx1f4l2_flxx_bqfset(*text, size, back, call);
		    if (delete) {
			break;
		    } else {
		    }
		}

		text++;

		news >>= 1;
	    }

	    nine = copy - (cast + 1 & ~1) >> 1;

	    for (; nine; nine--) {
		skip(node, size);
		delete = call(back, node);
		if (delete) {
		    break;
		}

		skip(node, size);
		if (news & 2) {
		    delete = _libx1f4l2_flxx_bqfset(*text, size, back, call);
		    if (delete) {
			break;
		    } else {
			delete = call(back, node);
			if (delete) {
			    break;
			}
		    }
		}

		text++;

		{
		    delete = _libx1f4l2_flxx_bqfset(*text, size, back, call);
		    if (delete) {
			break;
		    }
		}

		text++;

		news >>= 2;
	    }

	    if (copy & ~1) {
		skip(node, size);
		delete = call(back, node);
		if (delete) {
		    break;
		}
	    }

	    if (1) {
		if (copy & 1) {
		} else {
		    delete = ordain_data->lxpe
			(bqfset, *text, size, ever, back, call);
		    if (1) {
			break;
		    }
		}

		if (news & 2) {
		    delete = _libx1f4l2_flxx_bqfset(*text, size, back, call);
		    if (delete) {
			break;
		    } else {
		    edge:
			skip(node, size);
			delete = call(back, node);
			if (delete) {
			    break;
			}
		    }
		}

		text++;

		{
		    delete = ordain_data->lxpe
			(bqfset, *text, size, ever, back, call);
		}
	    }
	}
    } while (0);

    return delete;
}
