/*
 * lxdash-i.g.c
 * Copyright (C) 2011-2018, 2022, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <lxdash-inter.h>
#include <lxdash-drive.h>
#include <lxdash-types.h>

#define dxdash(list) \
    ((struct dxdash_type *) (list))
#define fxroll(roll) \
    ((struct fxroll_type *) (roll))
#define lxdash(list) \
    ((struct lxdash_type *) (list))

int
_libx1f4i0_lxdash_vamp_line(struct lxrail_type *lxrail_data,
			    struct fydata_type *fydata_data, void *dxdash,
			    void *fxroll)
{
    if (fxroll(fxroll)->tail < fxroll(fxroll)->head) {
	void *line;

	line = fydata_data;
	_libx1f4i0_fxpd_lxfset
	    (dxdash(dxdash)->dash, &fxroll(fxroll)->head, &line,
	     _libx1f4i0_lxdash_very_data);
#if 0
	(infer ? _libx1f4i0_lxpd_lxfset : _libx1f4i0_llpd_lxfset)
#else
	_libx1f4i0_llpd_lxfset
#endif				/* 0 */
	    (dxdash(dxdash)->dash, &fxroll(fxroll)->tail, &line,
	     _libx1f4i0_lxdash_very_data);
    } else {
	void *line;

	line = fydata_data;
	_libx1f4i0_ulpd_lxfset
	    (dxdash(dxdash)->dash, &fxroll(fxroll)->head,
	     &fxroll(fxroll)->tail, &line, _libx1f4i0_lxdash_very_data);
    }

    return 0;
}
