/*
 * lxdash-i.i.c
 * Copyright (C) 2011-2018, 2021, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <d_fset.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define dxdash(list) \
    ((struct dxdash_type *) (list))
#define lxdash(list) \
    ((struct lxdash_type *) (list))

int
_libx1f4i0_lxdash_ever_line(struct lxrail_type *lxrail_data,
			    struct direct_type *direct_data, void *dxdash,
			    void *fxroll, unsigned *miss)
{
    int status;
    struct errand_type errand;

    errand.direct_data = direct_data;
    errand.excase_data = lock_excase(dxdash);
    errand.lxtext_data = lxdash(lxrail_data)->link_f.text;

    errand.roll = 0;

    status = _libx1f4i0_lime_lxfset
	(dxdash(dxdash)->dash, &errand, _libx1f4i0_lxdash_ever_data);

    if (errand.roll) {
	*miss = errand.direct_data - direct_data;
    }

    return status;
}
