/*
 * lxdash-i.k.c
 * Copyright (C) 2011-2018, 2022, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>
#include <string.h>

#include <d_fset.h>
#include <lxdash-drive.h>
#include <lxdash-inter.h>
#include <lxdash-types.h>

#define dxdash(list) \
    ((struct dxdash_type *) (list))
#define lxdash(list) \
    ((struct lxdash_type *) (list))

int
_libx1f4i0_lxdash_wide_line(struct lxrail_type *lxrail_data,
			    struct affect_type *affect_data,
			    void *dxdash, void *fxroll,
			    unsigned *miss)
{
    int status;
    struct either_type either;

    either.excase_data = lock_excase(dxdash(dxdash));
    either.affect_data = affect_data;
    either.lxtext_data = lxdash(lxrail_data)->link_f.text;

    either.roll = 0;

    if (0) {
    } else {
	status = _libx1f4i0_lime_lxfset
	    (dxdash(dxdash)->dash, &either, _libx1f4i0_lxdash_rule_data);
    }

    if (either.roll) {
	*miss = either.affect_data - affect_data;
    }

    return status;
}
