/*
 * lxdash-i.w.c
 * Copyright (C) 2011-2018, 2022, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <lxdash-drive.h>
#include <lxdash-types.h>

int
_libx1f4i0_lxdash_rule_data(void *line, void *data)
{
    int link, status;
    struct affect_type *affect_data;
    struct effect_type *effect_data;
    struct either_type *either_data;

    either_data = line;

    affect_data = either_data->affect_data;

    effect_data = data;

    affect_data->link = effect_data->link;
    affect_data->type = effect_data->type;

    affect_data->fxdata = effect_data->fxdata;

    l_MODE(effect_data->mode, &affect_data->fxtext);

    link = affect_data->link;
    if (~link) {
	struct lxtext_type *lxtext_data;

	lxtext_data = either_data->lxtext_data + link;

	if (lxtext_data->lxtype.flags & X1f4_LX_LINK_ACCESS) {
	    status = lxtext_data->lxtype.node
		(lxtext_data->lxtype.context, (void *) &affect_data->fxdata,
		 I_USER(&affect_data->fxdata), either_data->excase_data);
	    if (status) {
	    } else {
		either_data->roll = 1;
		either_data->affect_data++;
	    }
	} else {
	    int (*copy)(void *, void *, void **, const void *,
			const struct x1f4_nodelink_type *);

	    copy = lxtext_data->lxtype.copy;
	    if (copy) {
		status = copy
		    (lxtext_data->lxtype.context, NULL,
		     (void *) &affect_data->fxdata,
		     I_USER(&affect_data->fxdata), either_data->excase_data);
		if (status) {
		} else {
		    either_data->roll = 1;
		    either_data->affect_data++;
		}
	    } else {
		status = 0;

		either_data->affect_data++;
	    }
	}
    } else {
	status = 0;

	either_data->affect_data++;
    }

    return status;
}
