/*
 * lxfile-n.d.c
 * Copyright (C) 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <exerrors.h>
#include <lxcast.h>
#include <lxfile-drive.h>
#include <lxfile-inter.h>
#include <lxfile-types.h>

int
_libx1f4i0_lxfile_d_nearest(void *context, void *output, void **input)
{
    int status;
    struct lxfile_type *lxfile_data;

    lxfile_data = context;

    do {
	int args[6];
	const struct x1f4_linetext_type *apply;
	struct x1f4_dxcast_type dxcast, *dxcast_data;
	struct x1f4_function_type function;
	struct x1f4_linetext_type linetext;
	void *file, *line[4], *park, **used;

	apply = lxfile_data->rule_l.apply;
	if (apply) {
	} else {
	    status = X1f4_EX_CAN_CONTINUE;
	    if (1) {
		break;
	    }
	}

	status = _libx1f4i0_lxfile_y_logique(context, &file, line);
	if (status) {
	    break;
	}

	line[2] = &file;
	line[3] = input[0];

	status = _libx1f4i0_lxfile_o_pending(context, &file, line + 2);
	if (status) {
	    break;
	}

	args[0] = lxfile_data->link_i.type;
	args[1] = X1f4_E4_TEXT;
	args[2] = 0;
	args[3] = X1f4_E4_POST_XSET;

	linetext.context = lxfile_data;
	linetext.function.args = args;
	linetext.function.count = 2;
	linetext.function.flags =
	    X1f4_E4_KEEP_CALL | X1f4_E4_LAST_CALL | X1f4_E4_POST_TYPE
	    | X1f4_E4_TEXT_LINK;
	linetext.function.function = _libx1f4i0_lxfile_c_magique;
	linetext.function.type = X1f4_E4_MODE;

	line[0] = input[-1];
	line[1] = &park;

	park = &dxcast;

	*(void **) &dxcast.data = &linetext;

	used = input[-1];
	used[X1f4_E4_RENDITION] = &function;

	function.count = 2;
	function.args = args + 4;
	function.flags = 0;

	args[5] = lxfile_data->link_i.type;

	status = apply->function.function
	    ((void *) apply->context, output, line + 1);
	if (status) {
	} else {
	    dxcast_data = I_USER(output);
	    l_USER(I_USER(&dxcast_data->data), output);
	}
    } while (0);

    return status;
}
