/*
 * lxline-d.s.c
 * Copyright (C) 2008-2011, 2013, 2014, 2016-2018, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <integral_q.h>
#include <l_note.h>
#include <lxcall.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_s_derived(void *context, void *output, void **input)
{
    X1f4_E4_C_TEXT half;
    int status;
    struct dxline_type *dxline_data, *dxline_text;

    dxline_data = I_LINE(input[0]);
    dxline_text = I_LINE(input[2]);

    half = I_TEXT(input[1]);

    if (1) {
	void *dxtext;

	status = _libx1f4i0_lxline_line_line(context, &dxtext);
	if (status) {
	} else {
	    status = _libx1f4i0_tear_sfnote
		(dxline_data->line, half, 0,
		 ((struct dxline_type *) dxtext)->line);
	    if (status) {
	    } else {
		void *way_red[4];

		way_red[0] = (void *) 0;
		way_red[1] = context;
		way_red[2] = lock_excase(dxline_data);
		way_red[3] = lock_excase(dxline_text);

		status = _libx1f4i0_lime_sfnote
		    (((struct dxline_type *) dxtext)->line, way_red,
		     _libx1f4i0_lxrail_love_rail);
		if (status) {
		} else {
		    unsigned miss;

		    miss = (integral_q) way_red[0];
		    dxline_data->size -= miss;
		    ((struct dxline_type *) dxtext)->size = miss;

		    status = _libx1f4i0_lxline_swap_line(dxtext, dxline_text);
		}
	    }

	    if (1) {
		int excess;

		excess = _libx1f4i0_lxline_flat_line(context, &dxtext);
		if (excess) {
		    status = _libx1f4i0_lxcall_land_slip(excess, status);
		}
	    }
	}
    }

    if (status) {
    } else {
	l_LINE(dxline_data, output);
    }

    return status;
}
