/*
 * lxline-i.h.c
 * Copyright (C) 2008-2016, 2018, 2019, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <l_note.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_east_line(struct lxrail_type *lxrail_data,
			    struct direct_type *direct_data, void *dxline,
			    void *fxroll, unsigned *miss)
{
    char *head, *tail;
    int rule, status;
    void *half, *part;

    head = fxroll(fxroll)->head;

    tail = fxroll(fxroll)->tail;

    rule = _x1f4_e4_text_diff(tail, head);

    if (rule < 0) {
	char *near;

	near = head;
	head = tail;
	tail = near; 
    }

    status = _libx1f4i0_lxline_mill_line
	(lxrail_data, dxline(dxline), head, tail, &half, &part, -1 < rule);
    if (status) {
    } else {
	int excess;
	struct either_type either;
	void *line;

	line = dxline(dxline)->line;

	either.excase_data = lock_excase(dxline);
	either.lxline_data = (void *) lxrail_data;
	either.lxtext_data = lxline(lxrail_data)->link_f.text;

	either.either = direct_data;

	either.roll = 0;
	either.tune = 0;

	if (rule < 0) {
	    status = _libx1f4i0_lime_sfnote
		(part, &either, _libx1f4i0_lxline_ever_data);
	    if (status) {
	    } else {
		status = _libx1f4i0_lime_sfnote
		    (line, &either, _libx1f4i0_lxline_ever_data);
	    }
	} else {
	    status = _libx1f4i0_lime_sfnote
		(half, &either, _libx1f4i0_lxline_ever_data);
	}

	if (either.roll) {
	    *miss = (struct direct_type *) either.either - direct_data;
	}

	excess = _libx1f4i0_join_sfnote(line, half);
	if (excess) {
	} else {
	    excess = _libx1f4i0_join_sfnote(line, part);
	}
	if (excess) {
	    if (status) {
	    } else {
		status = excess;
	    }
	}

	excess = _libx1f4i0_fini_sfnote(&half);
	if (excess) {
	    if (status) {
	    } else {
		status = excess;
	    }
	}

	excess = _libx1f4i0_fini_sfnote(&part);
	if (excess) {
	    if (status) {
	    } else {
		status = excess;
	    }
	}
    }

    return status;
}
