/*
 * lxline-i.k.c
 * Copyright (C) 2011-2017, 2022, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <l_note.h>
#include <lxline-inter.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_will_line(struct lxrail_type *lxline_data,
			    struct affect_type *affect_data, void *dxline,
			    void *fxroll, unsigned *miss)
{
    int status;
    struct either_type either;

    either.excase_data = lock_excase(dxline);
    either.lxline_data = (void *) lxline_data;
    either.lxtext_data = lxline(lxline_data)->link_f.text;

    either.either = affect_data;

    either.roll = 0;
    either.tune = 0;

    status = _libx1f4i0_span_sfnote
	(dxline(dxline)->line, &either, _libx1f4i0_lxline_rule_data);

    if (either.roll) {
	*miss = (struct affect_type *) either.either - affect_data;
    }

    return status;
}
