/*
 * lxline-i.g.c
 * Copyright (C) 2008-2016, 2018, 2019, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string.h>

#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-types.h>

extern const char *const x1f4_c1_empty_string;

int
_libx1f4i0_lxline_very_data(void *line, const char *text, unsigned size)
{
    int status;
    struct fydata_type *fydata_data;
    struct either_type *either_data;

    either_data = line;

    fydata_data = either_data->either;

    fydata_data++;

    either_data->either = fydata_data;

    if (size) {
	unsigned tune;

	size++;

	tune = either_data->tune;
	if (tune < size || 512 < size) {
	    status = _libx1f4i0_lxline_rule_text
		(fydata_data, text, size - 1, either_data);
	} else {
	    char *pass;

	    status = 0;

	    pass = either_data->pass;

	    memcpy(pass, text, size);

	    either_data->pass = pass + size;
	    either_data->tune = tune - size;

	    l_TEXT(pass, fydata_data);
	}
    } else {
	status = 0;

	l_TEXT((void *) x1f4_c1_empty_string, fydata_data);
    }

    return status;
}
