/*
 * lxline-j.d.c
 * Copyright (C) 2008-2018, 2022, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <l_note.h>
#include <lxline-drive.h>
#include <lxline-inter.h>
#include <lxline-parts.h>
#include <lxline-types.h>

int
_libx1f4i0_lxline_mill_line(void *lxline, void *dxline, char *lead, char *ever,
			    void **half, void **part, int envie)
{
    int status;
    struct x1f4_sfnote_type sfnote;
    void *line;

    sfnote.trans = &lxline(lxline)->link_m;

    line = dxline(dxline)->line;

    status = _libx1f4i0_init_sfnote(part, X1f4_SFNOTE_TRANS_MASK, &sfnote);
    if (status) {
    } else {
	status = _libx1f4i0_init_sfnote
	    (half, X1f4_SFNOTE_TRANS_MASK, &sfnote);
	if (status) {
	} else {
	    status = _libx1f4i0_tear_sfnote(line, ever, envie, *part);
	    if (status) {
	    } else {
		status = _libx1f4i0_tear_sfnote(line, lead, !envie, *half);
		if (status) {
		    _libx1f4i0_join_sfnote(line, *part);
		} else {
		}
	    }

	    if (status) {
		_libx1f4i0_fini_sfnote(half);
	    }
	}

	if (status) {
	    _libx1f4i0_fini_sfnote(part);
	}
    }

    if (status) {
	status = _libx1f4i0_lxline_stat_line(lxline, 0, status);
    }

    return status;
}
