/*
 * lxssxx-y.1.c
 * Copyright (C) 2016, 2018, 2019, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxcall.h>
#include <lxport-drive.h>
#include <lxport-inter.h>
#include <lxport-types.h>

int
_libx1f4i0_lxport_y_1sshell(void *context, void *output, void **input)
{
    int status;
    void *data;

    status = x1f4_line_ssport(context, &data);
    if (status) {
    } else {
	struct lxport_type *lxport_data;

	lxport_data = context;

	status = x1f4_raft_node
	    (&lxport_data->link_v, &lxport_data->link_e,
	     lxport_data->link_t.datatype, data);
	if (status) {
	    _libx1f4i0_lxport_slip_ssxx(context, &data);
	} else {
	    struct x1f4_function_type *function_data;
	    void **strip;

	    strip = input[-1];

	    function_data = strip[X1f4_E4_RENDITION];

	    status = _libx1f4i0_lxport_plan_ssxx
		(context, data, input[-1], output, function_data->count,
		 function_data->args, input);
	    if (status) {
	    } else {
		l_SSXX(data, output);
	    }
	}
    }

    return status;
}
