/*
 * lxssxx-4.p.c
 * Copyright (C) 2008-2012, 2014, 2019, 2024, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>
#include <string.h>

#include <e4.h>
#include <lxport-drive.h>
#include <lxport-inter.h>
#include <lxport-types.h>

int
_libx1f4i0_lxport_p_4sshell(void *context, void *output, void **input)
{
    int status;
    struct x1f4_function_type *function_data;
    struct ssport_type *ssport_data;
    unsigned count;
    void **strip;

    ssport_data = I_XSXX(input[0]);

    strip = input[-1];

    function_data = strip[X1f4_E4_RENDITION];

    status = 0;

    count = function_data->count - 1;
    if (count) {
	status = _libx1f4i0_lxport_plan_ssxx
	    (context, ssport_data, input[-1], output, count,
	     function_data->args + 1, input + 1);
    }

    if (status) {
    } else {
	l_SSXX(ssport_data, output);
    }

    return status;
}
